'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _listening = require('./listening');

var _listening2 = _interopRequireDefault(_listening);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FormField = function (_Listening) {
  _inherits(FormField, _Listening);

  function FormField() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, FormField);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = FormField.__proto__ || Object.getPrototypeOf(FormField)).call.apply(_ref, [this].concat(args))), _this), _this.value = null, _this.valid = true, _this.changed = false, _this.errorMessage = null, _this.setValue = function (value) {
      _this.value = value;
      _this.trigger('change', _this);
    }, _this.setValidation = function (valid) {
      var errorMessage = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

      _this.valid = valid;
      _this.errorMessage = errorMessage;
    }, _this.change = function () {
      var event = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;

      if (event !== null && 'target' in event && 'value' in event.target) {
        _this.changed = true;
        _this.setValue(event.target.value);
      }
    }, _this.changeValue = function (value) {
      _this.changed = true;
      _this.setValue(value);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  return FormField;
}(_listening2.default);

exports.default = FormField;