'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _Form = require('./common/Form');

var _Form2 = _interopRequireDefault(_Form);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var formInit = function formInit(inputAttr) {
  return function (target, propertyKey, descriptor) {
    target.__formInitialazers = target.__formInitialazers || [];

    target.__formInitialazers.push(function (context) {
      var options = context[propertyKey];
      var form = new _Form2.default(options);
      form.on('change', function () {
        if (context.forceUpdate) {
          context.forceUpdate();
        }
      });
      form.on('submit', function () {
        if (context.forceUpdate) {
          context.forceUpdate();
        }
      });
      context[propertyKey] = form;
    });

    return null;
  };
};

exports.default = formInit;